/*
    AutoX11, a tool to automate tasks in an X11 environment
    Copyright (C) 2014  Alicia <alicia@ion.nu>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>
#include <gtk/gtk.h>
#include "designer.h"

void add_typecmd(GtkButton* unused, void* d)
{
  GtkWidget* dialog=gtk_dialog_new_with_buttons("AutoX11 designer, type", GTK_WINDOW(mainwindow), GTK_DIALOG_MODAL, "_OK", GTK_RESPONSE_ACCEPT, "_Cancel", GTK_RESPONSE_CANCEL, (char*)0);
  GtkWidget* content=gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  GtkWidget* entry=gtk_entry_new();
  gtk_container_add(GTK_CONTAINER(content), entry);
  // Make pressing return while the entry is in focus work the same as clicking "OK"
  void ok(GtkWidget* x, void* y){gtk_dialog_response(GTK_DIALOG(dialog), GTK_RESPONSE_ACCEPT);}
  g_signal_connect(entry, "activate", G_CALLBACK(ok), 0);
  gtk_widget_show_all(dialog);
  if(gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_ACCEPT)
  {
    GtkTextBuffer* buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(srcview));
    GValue cursor=G_VALUE_INIT;
    g_value_init(&cursor, G_TYPE_INT);
    g_object_get_property(G_OBJECT(buffer), "cursor-position", &cursor);
    GtkTextIter iter;
    gtk_text_buffer_get_iter_at_offset(buffer, &iter, g_value_get_int(&cursor));
    char within=!(gtk_text_iter_starts_line(&iter)&&gtk_text_iter_ends_line(&iter));
    gtk_text_buffer_insert_at_cursor(buffer, "autox11 type '", 14);
    // TODO: escape stuff
    const char* text=gtk_entry_get_text(GTK_ENTRY(entry));
    gtk_text_buffer_insert_at_cursor(buffer, text, strlen(text));
    // Don't add a newline if the command was inserted into an existing expression
    if(!within)
    {
      gtk_text_buffer_insert_at_cursor(buffer, "'\n", 2);
    }else{
      gtk_text_buffer_insert_at_cursor(buffer, "'", 1);
    }
  }
  gtk_widget_destroy(dialog);
}
